function dCrit = ComputeCrossValidation(vX1, vX2, iB, dAdj, dCutOff)

    vQS        = quantile([vX1 vX2], [0 dCutOff (1- dCutOff) 1] );
    
    vQS(2)     = vQS(2) - dAdj;
    vQS(3)     = vQS(3) + dAdj;
        
    vEndPoints = [ vQS(2) ; vQS(3) ]; 

    iKappa     = 4;            % use cubic splines 
    iKnots     = iKappa + iB;  % number of knots 
    vXi        = linspace(vEndPoints(1),vEndPoints(2),iKnots+1);
    
    
    %  use first half to compute \gamma 
    mB1         = Bsplines(vX1, vXi, iKappa); 
    mC1         = BsplinesDer(vX1, vXi, iKappa);
    
    vGamma1    = pinv( (mB1*mB1') )* sum(mC1,2);
    
    
    %  use second half to compute \gamma 
    mB2         = Bsplines(vX2, vXi, iKappa); 
    mC2         = BsplinesDer(vX2, vXi, iKappa);
    
    vGamma2     = pinv( (mB2*mB2') )* sum(mC2,2);
    
    
    dC1g2       = vGamma1' * ( size(mB2,2)^-1 * (mB2*mB2')) * vGamma1 - 2 * vGamma1' * mean(mC2,2); 
    
    dC2g1       = vGamma2' * ( size(mB1,2)^-1 * (mB1*mB1')) * vGamma2 - 2 * vGamma2' * mean(mC1,2);  
    
    dCrit       = 0.5 * (dC1g2 + dC2g1); 
    
end