function [vPhi , mC] = ComputeDensityScore(vX, iB, dAdj, dCutOff)

    vQS        = quantile(vX, [0 dCutOff (1- dCutOff) 1] );
    
    vQS(2)     = vQS(2) - dAdj;
    vQS(3)     = vQS(3) + dAdj;
        
    vEndPoints = [ vQS(2) ; vQS(3) ]; 

    iKappa     = 4;            % use cubic splines 
    iKnots     = iKappa + iB;  % number of knots 
    vXi        = linspace(vEndPoints(1),vEndPoints(2),iKnots+1);
    
    mB         = Bsplines(vX, vXi, iKappa); 
    mC         = BsplinesDer(vX, vXi, iKappa);
    
    vGamma     = -pinv( (mB*mB') )* sum(mC,2);
    
    vPhi       = (mB' * vGamma)';    
    
end