function mWhat = GetEfficientWeight(mEpsH, iD, iT, vOrders, vInd)
    
    iKa     = size(vOrders,1);

    iB      = 1000; % # bootstrap reps  
    mBootM  = zeros(iKa ,iB);
  
    mU      =  floor( iT * rand(iD*iT,iB) ) +1;  
    
    for b = 1:iB 
        vU        = mU(:,b); 
        tmp       = mEpsH(:);
        
        vEpsB     = tmp(vU); 
        mEpsB     = reshape(vEpsB,[iD, iT]); 
            
        vMomentsGA = zeros(iKa,1);  % compute moments for AY
        for k=1:iKa 
            vPowers_j  = vOrders(k,:)';
            zeroPowers = find(vPowers_j == 0);
    
            tmp = mEpsB.^vPowers_j; 
        
            if ~isempty(zeroPowers) 
                help = setdiff(1:iD,zeroPowers);
                tmp  = prod(tmp(help,:),1);  
            else
                tmp  = prod(tmp,1);  
            end    
        vMomentsGA(k) = mean(tmp,2) - vInd(k);
        end  
        
        mBootM(:,b) = vMomentsGA;
    end
  mSigmaHat = iB^-1 * ((mBootM - mean(mBootM,2)) * (mBootM - mean(mBootM,2))'); 
  mWhat     = inv(iT * mSigmaHat); 
 
end