library("foreach")
library("ProDenICA") 
library("LogConcDEAD")
library("expm")
library("matlib")

source("~/Dropbox/ICA_Piotr/beyond_independence_in_ICA/Simulations/Revision/Replication/Helpers/Help_NPICA.R");


Data  <- read.csv('mY.csv',header=FALSE);
mY    <- as.matrix(Data);

iD    <- NROW(mY);
iT    <- NCOL(mY);

# ProDensICA  estimation 
mSigmaHat <- iT^-1 * (mY %*% t(mY));
mLigmaHat <- t(chol(mSigmaHat)); 
mYtilde   <- inv(mLigmaHat) %*% mY; 

W0 <- diag(iD); 
fit <- ProDenICA(t(mYtilde), W0=W0,Gfunc=GPois,trace=TRUE, density=TRUE)
mRhat <- fit$W;  
mAhatProDens <- mLigmaHat %*% mRhat; 
write.csv(mAhatProDens,'outProDens.csv');

# Nonparametric ML ICA 
mAhatNP_ICA <- fNP_ICA(mY, iD, iT, W0); 


write.csv(mAhatNP_ICA,'outNPICA.csv');



