function mA =  fAmatrix(vA, iK)
    
    % make skew-symmetric matrix mO 
    mO = zeros(iK,iK); 
    s  = 1;
    for k=1:iK
       mO(k,k+1:end) = vA(s:s+iK-k-1);
           
       mO(k+1:end,k) = -vA(s:s+iK-k-1); 
           
       s = s + size(vA(s:s+iK-k-1),1);
    end
    
    mA = (eye(iK) - mO) * inv(eye(iK) + mO);   % Cayley transform    
end



% %   what it computes is:   
%     if iK == 2
%        mO = [0 -vA(1) ; vA(1) 0 ]; 
%     end
%     if iK == 3
%        mO = [0 vA(1) vA(2) ; -vA(1) 0 vA(3) ; -vA(2) -vA(3) 0 ]; 
%     end
% 
%     if iK == 5
%        mO = [0 vA(1) vA(2) vA(3) vA(4) ; -vA(1) 0 vA(5) vA(6) vA(7) ; -vA(2) -vA(5) 0 vA(8) vA(9) ; -vA(3) -vA(6) -vA(8) 0 vA(10) ; -vA(4) -vA(7) -vA(9) -vA(10) 0 ]; 
%     end
 