function mA = fEfficientICA(mY, mAstart, dAdj, dCutOff, iBmax ) 

iT = size(mY,2);    % sample size 
iD = size(mY,1);    % dimension          

mA = mAstart;  % starting value 

for s=1:20
   
    invA = inv(mA);
    
    mEff_score = zeros(iD^2,iT);   % efficient score for d^2 x 1 

    mPhi = zeros(iD,iT);           % collect density scores  
    mTau = zeros(2,iD);            % tau coefficients    
    for k=1:iD
       vEpsK     = mA(k,:) * mY;

       mMK       = [ [ 1 mean(vEpsK.^3,2)] ; [mean(vEpsK.^3,2) (mean(vEpsK.^4) -1)]];

       vSelect   =  [0 ; -2];

       mTau(:,k) = inv(mMK) * vSelect;
       
       % split sample knot selection 
       vCrit = zeros(iBmax,1);
       for b=1:iBmax 
           vCrit(b) = ComputeCrossValidation(vEpsK(1:iT/2), vEpsK(iT/2+1:end), b, dAdj, dCutOff);
       end 
        
       iIndexMin = find( (vCrit(1:end-1) - vCrit(2:end)) < 0, 1);  

       mPhi(k,:) = ComputeDensityScore(vEpsK,iIndexMin, dAdj, dCutOff); 
    end
  
    for l=1:iD^2
        tmp = zeros(iD^2,1); tmp(l) = 1;
        mDl = reshape(tmp,[iD,iD]);

        for k=1:iD
            vEpsK = mA(k,:) * mY; 

            dZeta_lkk = mDl(k,:) * invA(:,k);

            mEff_score(l,:) = mEff_score(l,:) + dZeta_lkk * (mTau(1,k) * vEpsK + mTau(2,k) * (vEpsK.^2 -1)  ); 

            for j=1:iD
               if j ~= k
                   dZeta_ljk = mDl(k,:) * invA(:,j);
                   mEff_score(l,:) = mEff_score(l,:) + dZeta_ljk * mPhi(k,:) .* (mA(j,:) * mY);               
               end
            end
        end
    end
    
    mEffInf = iT^-1 * (mEff_score * mEff_score'); 
    
    vA      = vec(mA) + inv(mEffInf) * mean(mEff_score,2); 

    if norm(vA - vec(mA)) < 10^-5 
        break;
    else 
        mA = reshape(vA, [iD,iD]);
    end
end






end