function vE = fError(iType,iScale,iT)    % iScale = 0 no recscaling, 1 rescale sample, 2 rescale based on pop

if  iType == 1
    vE = normrnd(0,1,[1,iT]);    
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vE = vE; 
    end
end

if iType == 2
    vE = trnd(5,1,iT);
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vE = vE / sqrt( 5  /  (5 - 2)  ) ; 
    end
end


if iType == 3
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 1/5
            vE(t) = vR(t);
        end
        if (vU(t) <= 2/5) && (vU(t) >= 1/5)
            vE(t) = 0.5 + (2/3) * vR(t); 
        end
        if  vU(t) > 2/5 
            vE(t) = (13/12) + (5/9)* vR(t); 
        end
        
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.2 0.2 0.6] ;
       vMu  = [0 0.5 (13/12) ];
       vSig = [1 (2/3) (5/9)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end

if iType == 4
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 2/3
            vE(t) = vR(t);
        end
        if  vU(t) > 2/3
            vE(t) = (1/10) * vR(t); 
        end
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [(2/3)  (1/3) ] ;
       vMu  = [0  0];
       vSig = [1 (1/10)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end

if iType == 5
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 1/2
            vE(t) = -1 + (2/3) * vR(t);
        end
        if vU(t) > 1/2
            vE(t) = 1 + (2/3) * vR(t);
        end
    end
    
     if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.5 0.5] ;
       vMu  = [-1  1];
       vSig = [(2/3) (2/3)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end


if iType == 6
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 1/2
            vE(t) = -(3/2) + (1/2) * vR(t);
        end
        if vU(t) > 1/2
            vE(t) = (3/2) + (1/2) * vR(t);
        end
    end
    
     if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.5 0.5] ;
       vMu  = [(-2/3) (2/3)];
       vSig = [0.5 0.5];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end

if iType == 7
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 3/4
            vE(t) = vR(t);
        end
        if vU(t) > 3/4
            vE(t) = (3/2) + (1/3) * vR(t);
        end
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.75 0.25] ;
       vMu  = [0 (2/3) ];
       vSig = [1 (1/3)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end



if iType == 8 
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 9/20
            vE(t) = -(6/5) + (3/5) * vR(t);
        end
        if (vU(t) < 18/20) && (vU(t) > 9/20)
            vE(t) = (6/5) + (3/5) * vR(t);
        end
        if (vU(t) > 18/20)
            vE(t) = (1/4) * vR(t);
        end
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.75 0.25] ;
       vMu  = [0 (2/3) ];
       vSig = [1 (1/3)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end


if iType == 9 
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 1/2
            vE(t) = vR(t);
        end
        for l=0:4
            if (vU(t) < 1/2 + (l+1)/10) && (vU(t) > 1/2 + l/10)
                vE(t) = (l/2 -1) + (1/10) * vR(t);
            end
        end
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.75 0.25] ;
       vMu  = [0 (2/3) ];
       vSig = [1 (1/3)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end


if iType == 10 
    vU = rand(1,iT);
    vE = zeros(1,iT);
    vR = normrnd(0,1,[1,iT]);    
    
    for t=1:iT
        if vU(t) < 1/2
            vE(t) = vR(t);
        end
        for l=-2:2
            if (vU(t) < 1/2 + (2^(1-l +1) ) / 31 ) && (vU(t) > 1/2 + (2^(1-l) ) / 31)
                vE(t) = (l + 1/2) + (2^(-l)/10) * vR(t);
            end
        end
    end
    
    if iScale == 1
        vE = (vE - mean(vE,2)) ./ sqrt(var(vE,0,2)); 
    end
    if iScale == 2
       vW   = [0.75 0.25] ;
       vMu  = [0 (2/3) ];
       vSig = [1 (1/3)];
        
       dME  = vW * vMu'; 
       dVE  = vW * vSig'.^2 + vW * vMu'.^2 - (vW * vMu')^2; 
       vE   = (vE - ones(1,iT) * dME) ./ sqrt( ones(1,iT) * dVE ) ; 
    end
end


end