function [vOrders, vInd] = fGetOrders(iType, iR, iD)


  % inputs: 
  % iType : 1. diagonal , 2. reflectionally invariant  
  % iR    : order of tensor 
  % iD    : dimension of ICA model 

  % returns list:   
  % vOrders : all the restricted orders of the tensor           e.g. for r=3 and d=2 : (2,0), (0,2), (1,1), (2,1), (1,2) 
  % vInd    : vector of values corresponding to restrictions    e.g. for r=3 and d=2 : 1    , 1    , 0    , 0    , 0        
  
  
  % restricted orders for cumulant tensors (only for r=3,4).     
  
    if iType == 1  % diagonal tensors 
      if iR == 3 
        if iD == 2 
           vOrders = [ unique(perms( [2,0,zeros(1,iD-2)] ), 'rows') ; unique(perms( [1,1,zeros(1,iD-2)] ), 'rows')  ; unique(perms( [2,1,zeros(1,iD-2)]  ), 'rows')  ] ; 
        end
        if iD > 2 
          vOrders =  [ unique(perms( [2,0,zeros(1,iD-2)] ), 'rows') ; unique(perms( [1,1,zeros(1,iD-2)] ), 'rows')  ; unique(perms( [1,1,1,zeros(1,iD-3)] ), 'rows') ; unique(perms( [1,2,zeros(1,iD-2)] ), 'rows') ]; 
        end
      end
      if iR == 4
            if iD == 2
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2) ] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ),'rows') ; unique(perms( [2,2] ), 'rows') ; unique(perms( [3,1] ), 'rows')  ]; 
            end
            if iD == 3 
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2) ] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ), 'rows') ; unique(perms( [2,2, 0]), 'rows') ; unique(perms( [2,1, 1] ), 'rows') ; unique(perms([3,1 ,0]), 'rows')  ]; 
            end  
            if iD > 3
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2) ] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ), 'rows') ; unique(perms( [1,1,1,1,zeros(1,iD-4)] ), 'rows') ; unique(perms( [2,2,0, zeros(1,iD-3) ] ), 'rows') ; unique(perms( [2,1, 1, zeros(1,iD-3)] ), 'rows') ; unique(perms( [3,1 ,0, zeros(1,iD-3) ] ), 'rows')  ]  ; 
            end  
      end
    
      vInd  =  [ones(iD,1) ; zeros(size(vOrders,1)-iD,1)];
   end
  
   if iType == 2 
      if iR == 4
            if iD == 2
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2)] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ), 'rows') ; unique(perms([3,1]), 'rows') ]; 
            end
            if iD == 3
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2)] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ), 'rows') ; unique(perms( [3,1,0]), 'rows')  ; unique(perms( [2,1, 1] ), 'rows')   ]  ; 
            end
            if iD > 3 
                vOrders = [ unique(perms( [2,0,zeros(1,iD-2)] ), 'rows') ;  unique(perms( [1,1,zeros(1,iD-2)] ), 'rows') ; unique(perms( [1,1,1,1,zeros(1,iD-4)]), 'rows') ; unique(perms( [2,1, 1, zeros(1,iD-3)]), 'rows' ) ; unique(perms( [3,1,0, zeros(1,iD-3)]), 'rows')  ];   
            end  
      end
      vInd    = [ ones(iD,1) ; zeros( size(vOrders,1)-iD,1) ];
   end
   
  
end

