function dLL = fJcommonvariance2(vPar,vOrders,vInd,iD, iT, mY)

    mLigma = unvech(vPar(1:iD*(iD+1)/2));
    vD     = exp(diag(mLigma)); 
    mLigma(1:iD+1:end) = vD; 
   
    vAlpha = vPar(iD*(iD+1)/2 + 1:end); 
    mR     = fAmatrix(vAlpha, iD);
    mA     = mR' * mLigma;
    
    iKa    = size(vOrders,1);
    vMoments = zeros(iKa,1);
    
    for j=1:iKa
       vPowers_j  = vOrders(j,:)';
       vMoments(j) = mean(prod((mA * mY).^vPowers_j, 1),2) - vInd(j);
    end   
    
    mOmegaHat = zeros(iKa,iKa);  
    for i=1:iKa
        for j=1:iKa
            vPowers_i  = vOrders(i,:)';
            vPowers_j  = vOrders(j,:)';
             
            tmp_i = prod((mA * mY).^vPowers_i,1); 
            tmp_j = prod((mA * mY).^vPowers_j,1);   

            mOmegaHat(i,j) = iT^-1 * (tmp_i - mean(tmp_i,2)) * (tmp_j - mean(tmp_j,2))';
        end
    end
    
    if isnan(rcond(mOmegaHat)) || rcond(mOmegaHat) < 10^-10
        dLL    =  vMoments' * vMoments;
    else
        dLL    =  vMoments' * (mOmegaHat \ vMoments);
    end 
end