function dLL = fJcommonvariance2White(vPar,vOrders,vInd,iD, iT, mY)

    mR     = fAmatrix(vPar, iD);
    mA     = mR';
    
    iKa    = size(vOrders,1);
    vMoments = zeros(iKa,1);
    
    for j=1:iKa
       vPowers_j  = vOrders(j,:)';
       vMoments(j) = mean(prod((mA * mY).^vPowers_j),2) - vInd(j);
    end   
    
    mOmegaHat = zeros(iKa,iKa);  
    for i=1:iKa
        for j=1:iKa
            vPowers_i  = vOrders(i,:)';
             
            vPowers_j  = vOrders(j,:)';
             
            tmp_i = prod((mA * mY).^vPowers_i,1); 
            tmp_j = prod((mA * mY).^vPowers_j,1);   

            mOmegaHat(i,j) = iT^-1 * (tmp_i - vInd(i)) * (tmp_j - vInd(j))';
        end
    end
    
    if isnan(rcond(mOmegaHat)) || rcond(mOmegaHat) < 10^-20 
        dLL    = vMoments' * vMoments;
    else
        dLL    =  vMoments' * (mOmegaHat \ vMoments);
    end 
end