function [mA,s] = fNonparametricICA(mY, vAinit) 

iT = size(mY,2);    % sample size 
iD = size(mY,1);    % dimension    

% gamma      = 100;
% optOptions = struct('verbose',2,'cutoff',10^-1,'method',@newtonBFGSL,'lambdaSqEps',10^-7,'intEps',10^-3);


% Step 1: pre-whitening 
mSigmaHat = iT^-1 * (mY * mY');
mLigmaHat = chol(mSigmaHat,'lower');
mYtilde   = inv(mLigmaHat) * mY; 


% Step 2: iterate estimate f_1, ... , f_d and R 
mR     = fAmatrix(vAinit, iD); % initial estimate 
Yplus  = [ [0 , -2^(-0.5)] ; [2^(-0.5) , 0 ] ];
Yminus = -Yplus; 

dGold = -10;
for s=1:100

    % estimate densities 
    mLogLik = zeros(iD,iT); 
    mAopt   = cell([iD,1]);
    mBopt   = cell([iD,1]);

    for k=1:iD
        csvwrite('in.csv',(mR(k,:) * mYtilde)');  % write to csv 
        !R CMD BATCH /home/geert/Dropbox/ICA_Piotr/beyond_independence_in_ICA/Simulations/Revision/Matlab/LogDensScore.R 
        
        mAopt{k} = csvread('outB.csv',1,1);
        mBopt{k} = csvread('outBeta.csv',1,1);
        mLogLik(k,:) = csvread('outLoglik.csv',1,1);


%         [mAopt{k} , mBopt{k} , mLogLik(k,:) , ~] = lcdFast((mR(k,:) * mYtilde)',gamma,optOptions);  
    end
        
    mK     = zeros(iD,iT); 
    mBfit  = zeros(iD, iT);
    for t=1:iT
        for i=1:iD
            
            vAopt  = mAopt{i};
            vBopt  = mBopt{i};
            
            tmp = zeros(size(vAopt,1),1);
            for k=1:size(vAopt,1)
               tmp(k) = vAopt(k) * (mR(i,:) * mYtilde(:,t)) -  vBopt(k);  
            end
                      
            [~, indexK] = min(tmp); 
            
            mK(i,t) = indexK;     
            
            mBfit(i,t) = mAopt{i}(mK(i,t));
        end
    end
    
    % update R matrix 
    dGradPlus  = fEvaluateGder(mYtilde, mR, mAopt, mBopt, iD, iT, mR * Yplus);   % compute gradient functions
    dGradminus = fEvaluateGder(mYtilde, mR, mAopt, mBopt, iD, iT, mR * Yminus);
    
    if  dGradPlus > dGradminus
        Ymax = Yplus; 
    else
        Ymax = Yminus; 
    end

    dGw    = fEvaluateG(mYtilde, mR, mAopt, mBopt, iD, iT); 
    dGderw = fEvaluateGder(mYtilde, mR, mAopt, mBopt, iD, iT, mR * Ymax);
    
    alpha  = 0.3;
    lambda = 0.5;
    eps    = 1;
    
    while eps > 10^-10
        
        mRnew = mR * expm( eps * Ymax );
        dGnew = fEvaluateG(mYtilde, mRnew, mAopt, mBopt, iD, iT); 

        dRHS  = dGw + alpha * eps *  dGderw;  
        
        if dGnew > dRHS 
            mR = mRnew;
            break; 
        else
            eps = eps * lambda;
        end   
    end
    
    if ((dGnew - dGold) / abs(dGold)) < 10^-10  
        break;
    else
        dGold = dGnew;
    end
end

mAinv   = mLigmaHat * inv(mR); 
mA      = inv(mAinv);

end