function mYnew = fStandardize(mY) 
    
    [iD,iT] = size(mY);
    
    tmp1    = fGetOrders(1, 3, iD);
    tmp2    = fGetOrders(2, 4, iD);

    mOrders = unique([tmp1;tmp2], 'rows');
    
    mMoments      = [];
    for j=1:size(mOrders,1)
         mMoments = [mMoments ; prod(mY.^(mOrders(j,:)'),1)]; 
    end
    
    vGbar = zeros(size(mOrders,1) , 1); 
    for j=1:size(mOrders,1) 
       if sum(mOrders(j,:),2) == 2 && min(mOrders(j,:)) == 0 
          vGbar(j) = 1;
       end 
    end

    vGammaStart = 0.01 * ones(size(mOrders,1) , 1); 
    options     = optimoptions('fminunc','Display','notify','MaxFunctionEvaluations',1e4, 'MaxIterations',1e3);
    [vGammaHat,dLL,iExitflag] = fminunc(@fGammaEst,vGammaStart,options,mMoments, vGbar);
    
    vWeightsNew = iT^-1 * exp(vGammaHat' * mMoments) / mean( exp(vGammaHat' * mMoments) , 2); 
    
    mYnew = vWeightsNew .* mY; 
end