function mAhat = fTICA(mY, vAinit)   % TICA estimation common variance model

[iD, iT]         = size(mY); 

mSigmaInit       = iT^-1 * (mY * mY');
mLigmaInit       = chol(mSigmaInit,'lower');
    
vStart           = [vech(mLigmaInit) ; vAinit];              % starting values
vH               = ones(iD,1);                         % neighborhood function 

options          = optimoptions('fminunc','Display','notify','MaxFunctionEvaluations',1e4, 'MaxIterations',1e3);
[vParHat,~,iExitflag] = fminunc(@fTICAlik,vStart,options, mY, vH);
if iExitflag<=0; warning('Unrestricted MLE did not converge, exit flag: %g',iExitflag); end

mSigmaHat        = unvech(vParHat(1:iD*(iD+1)/2));
vDhat            = exp(diag(mSigmaHat)); 
mSigmaHat(1:iD+1:end) = vDhat;    
vAlphaHat        = vParHat(iD*(iD+1)/2 + 1:end); 
mRhat            = fAmatrix(vAlphaHat, iD);
% mAinvHat         = mSigmaHat * inv(mRhat); 
% mAhat            = inv(mAinvHat);
mAhat            = mRhat' * mSigmaHat; 


end